unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPMan, TlHelp32, XKERNEL, xStrings, xFiles, Inject;

type
  TForm1 = class(TForm)
    lbl1: TLabel;
    lstProcess: TListBox;
    btnMonitor: TButton;
    btnRefresh: TButton;
    xpt1: TXPManifest;
    procedure btnRefreshClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnMonitorClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation


{$R *.dfm}

procedure TForm1.btnRefreshClick(Sender: TObject);
var
  hsnap, hwin: THandle;
  pentry: TProcessEntry32;
  wname: array[0..255] of Byte;
begin
  lstProcess.Clear;
  hsnap := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  if hsnap = INVALID_HANDLE_VALUE then begin
    ShowMessage('LkCX{.');
    Exit;
  end;
  pentry.dwSize := SizeOf(pentry);
  if not Process32First(hsnap, pentry) then begin
    CloseHandle(hsnap);
    Exit;
  end;
  repeat
    hwin := GetHWndByPID(pentry.th32ProcessID);
    if hwin = 0 then
      Continue;
    GetWindowText(hwin, @wname[0], 256);
    lstProcess.Items.Add(Format('%.8X-%s', [pentry.th32ProcessID, StrPas(@wname[0])]));
  until not Process32Next(hsnap, pentry);
  CloseHandle(hsnap);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  btnRefresh.Click;
end;

procedure TForm1.btnMonitorClick(Sender: TObject);
var
  pid: DWORD;
begin
  if lstProcess.ItemIndex = -1 then
    Exit;
  pid := StrToInt('$'+GetToken(lstProcess.Items[lstProcess.ItemIndex], 1, False, ['-']));
  InjectDll(pid, AppDir+'Core.dll');
end;

end.
